unit hiDrawCard;

interface

uses Windows,Kol,Share,Debug,Cards;

type
  THIDrawCard = class(TDebug)
   private
     szX, szY:integer;

   public
    _prop_CardBack:integer;
    _prop_CardHighlighted:byte;
    _prop_Color:TColor;
    _prop_X:integer;
    _prop_Y:integer;

    _data_Handle:THI_Event;
    _data_Color:THI_Event;
    _data_CardHighlighted:THI_Event;
    _data_CardBack:THI_Event;
    _data_Card:THI_Event;
    _data_X:THI_Event;
    _data_Y:THI_Event;
    _event_onDraw:THI_Event;

    procedure _work_DrawFaceUp(var _Data:TData; Index:word);
    procedure _work_DrawFaceDown(var _Data:TData; Index:word);
    procedure _work_DrawGhost(var _Data:TData; Index:word);
    procedure _work_DrawRemove(var _Data:TData; Index:word);
    procedure _var_SizeX(var _Data:TData; Index:word);
    procedure _var_SizeY(var _Data:TData; Index:word);
    constructor Create; 
    destructor Destroy; override;
  end;

implementation

constructor THIDrawCard.Create; 
begin
   inherited Create;
   if (not initOK) then
   begin
     if (cdtInit(szX, szY) = 1) then initOK := true else initOK := false;
   end;
end;

destructor THIDrawCard.Destroy;
begin
  if (initOK) then
  begin  
    cdtTerm;
    initOK := false;
  end;
  inherited;
end;

procedure THIDrawCard._work_DrawFaceUp;
var
   dc:HDC;
   Wnd:HWND;
   x,y:integer;
   c:TColor;
   Card:integer;
   highlighted:integer;
   result:integer;
begin
  result := 0;
  if (initOK) then
  begin
    Card := ReadInteger(_Data,_data_Card,66);
    dtNull(_Data);
    Wnd := ReadInteger(_Data,_data_Handle,0);
    dc := GetDC(wnd);
    x := ReadInteger(_Data,_data_X,_prop_X);
    y := ReadInteger(_Data,_data_Y,_prop_Y);
    c := ReadInteger(_Data,_data_Color, _prop_Color);
    highlighted := 2 * ReadInteger(_Data, _data_CardHighlighted, 0);
    result := cdtDraw(dc, x, y, card, highlighted, c);  
    ReleaseDC(Wnd,DC);
  end;
  _hi_OnEvent(_event_onDraw, result);
end;

procedure THIDrawCard._work_DrawFaceDown;
var
   dc:HDC;
   Wnd:HWND;
   x,y:integer;
   Card:integer;
   c:TColor;
   result:integer;
begin
  result := 0;
  if (initOK) then
  begin
    Card := ReadInteger(_Data,_data_CardBack,_prop_CardBack);
    {if (Card < 53) then} Inc(Card,53);
    dtNull(_Data);
    Wnd := ReadInteger(_Data,_data_Handle,0);
    dc := GetDC(wnd);
    x := ReadInteger(_Data,_data_X,_prop_X);
    y := ReadInteger(_Data,_data_Y,_prop_Y);
    c := ReadInteger(_Data,_data_Color, _prop_Color);
    result := cdtDraw(dc, x, y, card, FaceDown, c);  
    ReleaseDC(Wnd,DC);
  end;
  _hi_OnEvent(_event_onDraw, result);
end;

procedure THIDrawCard._work_DrawGhost;
var
   dc:HDC;
   Wnd:HWND;
   x,y:integer;
   c:TColor;
   result:integer;
begin
  result := 0;
  if (initOK) then
  begin
    dtNull(_Data);
    Wnd := ReadInteger(_Data,_data_Handle,0);
    dc := GetDC(wnd);
    x := ReadInteger(_Data,_data_X,_prop_X);
    y := ReadInteger(_Data,_data_Y,_prop_Y);
    c := ReadInteger(_Data,_data_Color, _prop_Color);
    result := cdtDraw(dc, x, y, 1, Ghost, c);  
    ReleaseDC(Wnd,DC);
  end;
  _hi_OnEvent(_event_onDraw, result);
end;

procedure THIDrawCard._work_DrawRemove;
var
   dc:HDC;
   Wnd:HWND;
   x,y:integer;
   c:TColor;
   result:integer;
begin
  result := 0;
  if (initOK) then
  begin
    dtNull(_Data);
    Wnd := ReadInteger(_Data,_data_Handle,0);
    dc := GetDC(wnd);
    x := ReadInteger(_Data,_data_X,_prop_X);
    y := ReadInteger(_Data,_data_Y,_prop_Y);
    c := ReadInteger(_Data,_data_Color, _prop_Color);
    result := cdtDraw(dc, x, y, 1, Remove, c);  
    ReleaseDC(Wnd,DC);
  end;
  _hi_OnEvent(_event_onDraw, result);
end;

procedure THIDrawCard._var_SizeX;
begin
  if (initOK) then dtInteger(_Data, szX) else dtInteger(_Data, 0);
end;

procedure THIDrawCard._var_SizeY;
begin
  if (initOK) then dtInteger(_Data, szY) else dtInteger(_Data, 0);
end;

end.